config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :committees do
    match 'trials', to: 'trials#clear_permitted_trials', via: :delete, as: 'trial_clear_permitted'
    resources :trials do
      match 'state/:state_id', to: 'trials#set_state', via: :patch, as: 'set_state'
      match 'authorize/:private_key_digest', to: 'trials#receive_private_key_digest', via: :get,
                                             as: :authorize
      match '', to: 'trials#receive_private_key', via: :post
      match 'versions', to: 'trials#versions', via: :get
      match 'versions', to: 'trials#delete_versions', via: :delete
      match 'comment', to: 'trials#comment', via: :post
      resources :tasks, only: [:create, :update, :destroy, :edit]
      post 'upload', to: 'trials#upload'
    end
    resources :ranks, only: [:create, :destroy]
    resources :environments, only: [:create, :destroy, :edit, :update]
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get
  match 'permitted_keywords' => 'home#permitted_keywords', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{ content: 'text/html; charset=UTF-8',
    'http-equiv': 'Content-Type' }/
    %meta{ content: 'width=device-width, initial-scale=1',
    name: 'viewport' }/
    %title Zaki
    = csrf_meta_tags
    = stylesheet_link_tag    'application', media: 'all',
    'data-turbolinks-track': 'reload'
    = stylesheet_link_tag    params[:controller], media: 'all',
    'data-turbolinks-track': 'reload'
    = javascript_include_tag 'application', 'data-turbolinks-track': 'reload'
  %body{ class: "#{controller_name} #{action_name}" }
    %nav.navbar#main-navbar
      %button.navbar-toggler{ 'aria-controls': 'navbar-nav',
      'aria-expanded': 'false', 'aria-label': 'Toggle navigation',
      'data-target': '#navbar-nav', 'data-toggle': 'collapse',
      type: 'button' }
        %span.navbar-toggler-icon
      %a.navbar-brand{ href: '/' } Zaki
      .collapse.navbar-collapse#navbar-nav
        %ul.navbar-nav
          - if current_user.present?
            %li.nav-item
              - if @committee.present? && @committee.persisted?
                = link_to @committee.name, @committee, class: 'nav-link'
              - else
                = link_to t(:all_committees), :committees, class: 'nav-link'
            %li.nav-item
              - if @committee.present? && @committee.persisted?
                = link_to t(:trials_list), committee_trials_path(@committee),
                class: 'nav-link'
            - if current_user.admin? && @committees&.one?
              %li.nav-item
                = link_to t(:new_committee), new_committee_path,
                class: 'nav-link'
          - if @committee.present? && @committee.persisted?
            %li.nav-item
              = link_to t(:meetings), formsub_meetings_url,
              class: 'nav-link'
        - if current_user.present?
          %ul.navbar-nav.ml-auto
            %li.nav-item
              = link_to logout_path, method: :delete,
              class: 'btn btn-outline-danger', title: t(:logout),
              'data-toggle': 'tooltip', 'data-placement': 'bottom',
              'data-offset': '0 10' do
                %i.fa.fa-sign-out
    .container-fluid
      = yield

    :javascript
      if (innerWidth > 767) {
        $('[data-toggle="tooltip"]').tooltip({
         container: 'body'
        })
      }
      $('[data-toggle="popover"]').popover()